<?php
/**
* @copyright Copyright (C) 2006 - 2010 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/
defined('_JEXEC') or die();

class JElementDmCat3 extends JElement
{
	function fetchElement($name, $value, &$node, $control_name)
	{
		global $mainframe;
		
		if( !is_dir(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_docman') ){
	    	return '<b>DOCman is not installed on your Joomla site</b>';
	    }

		$db	= &JFactory::getDBO();
		$user = &JFactory::getUser();
		
		$multi = $node->attributes('multiple');
		
		$sql = "SELECT c.id, c.title"
         . "\n FROM #__categories c"
         . "\n WHERE section='com_docman'"
         . "\n AND published AND access <= ".$user->gid;
         
        $sql_end = "\n ORDER BY ordering" ;
             
	 	if( $mainframe->isSite() ) {
			if (!empty($value) ) {
				$sql .= ' AND c.id IN('.implode(',',$value).') '.$sql_end ;
				$db->setQuery($sql);
				$result = $db->loadObjectList();
			}
		} else {
			$sql .= $sql_end;
			$db->setQuery($sql);
			$result = $db->loadObjectList();
		}
		
		$options = array();
		
		foreach( $result as $option ){
			$options[] = JHTML::_( 'select.option', $option->id, $option->title );
		}
		
		if( $multi ){
			$element_name = "{$control_name}[{$name}][]";
			$additional   = ' multiple="multiple" ';
		} else {
			$element_name = "{$control_name}[{$name}]";
			$additional   = '';
		}
		
		$html	= JHTML::_( 'select.genericlist',  $options, $element_name, ''.$additional, 'value', 'text', $value );
            
		return $html;
	}
}
?>